#include "palette.h"

#ifdef DEST_TYPE
#undef DEST_TYPE
#endif

#ifdef TEXSRC_TYPE
#undef TEXSRC_TYPE
#endif

#ifdef TEXSRC_TO_DEST
#undef TEXSRC_TO_DEST
#endif

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif

#if SRC_TEXFORMAT == TEXFORMAT_ARGB32
	#define DEST_TYPE UINT32
	#define TEXSRC_TYPE UINT32
	#define TEXSRC_TO_DEST(src) (src)
	#define FUNC_NAME(name) name ## _argb32
#elif SRC_TEXFORMAT == TEXFORMAT_PALETTE16
	#define DEST_TYPE UINT16
	#define TEXSRC_TYPE UINT16
	#define TEXSRC_TO_DEST(src) \
		((texsource->palette[src]&0xf80000) >> 8 | \
		 (texsource->palette[src]&0x00fc00) >> 5 | \
		 (texsource->palette[src]&0x0000f8) >> 3)
	#define FUNC_NAME(name) name ## _palette16
#elif SRC_TEXFORMAT == TEXFORMAT_RGB15
	#define DEST_TYPE UINT16
	#define TEXSRC_TYPE UINT16
	#ifdef SRC_PALETTED
		#define TEXSRC_TO_DEST(src) \
			((texsource->palette[((src) >> 10) & 0x1f] & 0xf8) << 8 | \
			 (texsource->palette[((src) >> 5)  & 0x1f] & 0xfc) << 3 | \
			 (texsource->palette[(src) & 0x1f] & 0xf8) >> 3)
		#define FUNC_NAME(name) name ## _rgb15_paletted
	#else
		#define TEXSRC_TO_DEST(src) (src)
 		#define FUNC_NAME(name) name ## _rgb15
	#endif
#elif SRC_TEXFORMAT == TEXFORMAT_RGB32
	#define DEST_TYPE UINT32
	#define TEXSRC_TYPE UINT32
	#ifdef SRC_PALETTED
		#define TEXSRC_TO_DEST(src) \
			(texsource->palette[0x200 + RGB_RED(src)]   | \
			 texsource->palette[0x100 + RGB_GREEN(src)] | \
			 texsource->palette[RGB_BLUE(src)])
		#define FUNC_NAME(name) name ## _rgb32_paletted
	#else
		#define DEST_TYPE UINT32
		#define TEXSRC_TO_DEST(src) (src)
		#define FUNC_NAME(name) name ## _rgb32
	#endif
#else
	#error Unknown SRC_TEXFORMAT
#endif
